Subject: bug#33442: 26.1.90; Cairo side-by-side windows scrolling fix should be cherry-picked

From: Ari Roponen <[email-masked]>
Date: Thu, 22 Nov 2018 08:44:19 +0200

Dmitry Gutov <[email-masked]> writes:

> On 21.11.2018 9:11, Ari Roponen wrote:
>
>> I have been using --with-cairo for my Emacs builds for six months, and
>> haven't had any major problems with it.
>
> Curious.
>
> I've just tried building the master branch --with-cairo (on
> GNU/Linux), and I see crippling rendering problems right away. Maybe
> the same issue as reported at
> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=23925.
>

It does work here. I use gnome-shell on Xwayland.
Could you try the following patch, if it helps?

diff --git a/src/xterm.c b/src/xterm.c
index 3a7e31e712..e82beacd7d 100644
--- a/src/xterm.c
+++ b/src/xterm.c
@@ -992,6 +992,9 @@ x_update_begin (struct frame *f)
   if (FRAME_TOOLTIP_P (f) && !FRAME_VISIBLE_P (f))
     return;
 
+  if (FRAME_GARBAGED_P (f))
+    x_cr_destroy_surface (f);
+
   if (! FRAME_CR_SURFACE (f))
     {
       int width, height;